$Title LogMIP User's Manual Example 1a - Job Scheduling (LOGMIP1A,SEQ=332)
$ontext
Three jobs (A,B,C) must be executed sequentially in three steps, but
not all jobs require all the stages. The objective is to obtain the
sequence of tasks which minimizes the completion time. Once a job has
started it cannot be interrupted. The objective is to obtain the
sequence of task, which minimizes the completion time.

Ref: Raman & Grossmann, Comp. & Chem. Eng., 18, 7, p.563-578, 1994.

Aldo Vecchietti, LogMIP User's Manual, http://www.logmip.ceride.gov.ar/
$offtext

POSITIVE VARIABLES XA,XB,XC,T;

VARIABLE Z;
EQUATIONS equat1, equat2, equat3, equat4, equat5, equat6,
          equat7, equat8, equat9, OBJECTIVE;

equat1.. T =G= XA + 8;
equat2.. T =G= XB + 5;
equat3.. T =G= XC + 6;

equat4.. XA-XC =L= -5;
equat5.. XC-XA =L= -2;
equat6.. XB-XC =L= -1;
equat7.. XC-XB =L= -6;
equat8.. XA-XB =L= -5;
equat9.. XB-XA =L=  0;


OBJECTIVE.. Z =E= T;

option EMP=LOGMIP;
MODEL PEQUE1 /ALL/;

XA.UP=20;
XB.UP=20;
XC.UP=20;

$ONECHO > "%LM.info%"
* by default the convex hull reformulation is used
disjunction  * equat4 else equat5
disjunction  * equat6 else equat7
disjunction  * equat8 else equat9

* optional, if not set EMP will find the modeltype suitable
modeltype mip
$OFFECHO

SOLVE PEQUE1 USING EMP MINIMIZING Z;
