$Title LogMIP User's Manual Example 1a - Job Scheduling (LOGMIP1A,SEQ=332)
$ontext
Three jobs (A,B,C) must be executed sequentially in three steps, but
not all jobs require all the stages. The objective is to obtain the
sequence of tasks which minimizes the completion time. Once a job has
started it cannot be interrupted. The objective is to obtain the
sequence of task, which minimizes the completion time.

Ref: Raman & Grossmann, Comp. & Chem. Eng., 18, 7, p.563-578, 1994.

Aldo Vecchietti, LogMIP User's Manual, http://www.logmip.ceride.gov.ar/
$offtext

*Third Version - Alex Meeraus compact version
SETS J JOBS   / A, B, C /
          S STAGES / 1*3 /
         GG(J,J) Upper Triangle
ALIAS (J,JJ),(S,SS);

TABLE P(J,S)  Processing Time
       1     2     3
  A    5           3
  B          3     2
  C    2     4

PARAMETER
          C(J,S)                Stage Completion Time
          W(J,JJ)        Maximum Pairwise Waiting Time
          PT(J)           Total Processing Time
          BIG             The Famous Big M;

GG(J,JJ) = ORD(J) < ORD(JJ);

C(J,S)   = SUM(SS$(ORD(SS)<=ORD(S)), P(J,SS));
W(J,JJ) = SMAX(S, C(J,S) - C(JJ,S-1));
PT(J)    = SUM(S, P(J,S));
BIG      = SUM(J, PT(J));

VARIABLES  T           Completion Time
           X(J)       Job Starting Time
           Y(J,JJ)   Job Precedence

POSITIVE VARIABLE X;
BINARY VARIABLE Y;

EQUATIONS COMP(J)    Job Completion Time
          SEQ(J,JJ)   Job Sequencing
          DUMMY;


COMP(J).. T =G= X(J) + PT(J);
SEQ(J,JJ)$(ORD(J) <> ORD(JJ))..  X(J) + W(J,JJ) =L= X(JJ);
DUMMY.. SUM(GG(J,JJ), Y(J,JJ)) =G= 0;

X.UP(J) = BIG;

MODEL SMALL13 / ALL /;

file lg / '%lm.info%' /; put lg '* problem %gams.i%';
loop(gg(j,jj)$(ord(j) <> ord(jj)),
   put / 'disjunction ' Y(j,jj)  seq(j,jj) 'else' seq(jj,j));
putclose;



OPTION EMP = LOGMIP;
OPTION OPTCR=0.0;
MODEL SMALL11 /ALL/;
SOLVE SMALL11 USING EMP MINIMIZING T;
